      SUBROUTINE ABMULT(VA,VAD,Y,X,CI,NRN)
C.....Multiplies A_rb*y for black nodes
c      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
c      DOUBLE PRECISION VA,VAD,X,Y,S
      INTEGER CI,NRN
      DIMENSION CI(6,*)
      DIMENSION X(*),Y(*),VA(6,*),VAD(*)
C...
      DO 10 IRN=1,NRN
         S = 0.0
         DO 5 JC=1,6
            JCOL = CI(JC,IRN)
            IF (JCOL.GT.0) S = S+VA(JC,IRN)*Y(JCOL-NRN)
    5    CONTINUE
         X(IRN) = S/VAD(IRN)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE ARMULT(VA,Y,X,CI,NBN,NRN)
C.....Multiplies A_br^T*y for red nodes
C.....      A_br^T(=A_rb)
c      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
c      DOUBLE PRECISION VA,X,Y,S
      INTEGER NBN,NRN,CI
      DIMENSION X(*),Y(*),VA(6,*),CI(6,*)
C...
      DO 10 I=1,NBN
         IB = I+NRN
         S = 0.0
         DO 5 J=1,6
            JR = CI(J,IB)
            IF (JR.GT.0) S = S+VA(7-J,JR)*Y(JR)
    5    CONTINUE
         X(I) = S
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CGRIES(VA,VAD,RHS,AP,PP,RA,RR,SS,XX,WW,WORK,
     X     EPSSLV,MAXIT,CI,CIR,CIRL,CIRH,NXYZ,NRN,NBN,
     X     IOUTS,ITRN,NCXIT)
c      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
c      DOUBLE PRECISION VA,VAD,RHS
c      DOUBLE PRECISION AP,PP,RA,RR,SS,XX,WW,WORK
c      DOUBLE PRECISION ALPHA,DELTA,H,R1,R00,RAT
c      DOUBLE PRECISION XIP
      INTEGER MAXIT,NBN,NRN,NXYZ
      INTEGER CI,CIR,CIRH,CIRL,MAR,MAR1
c      INCLUDE 'param0.inc'
      COMMON/CAIS/MAR(6,6),MAR1(19,19)
      DIMENSION VA(6,NBN),VAD(NXYZ),RHS(0:NXYZ)
      DIMENSION AP(NBN),PP(NBN),RA(10,NBN),RR(NBN),SS(NBN),
     X     XX(NBN),WW(NBN),
     X     WORK(NBN)
      DIMENSION CI(6,NXYZ),CIR(19,NBN),CIRH(10,NBN),CIRL(10,NBN)
C...
      R00 = SQRT(XIP(RHS,RHS,NXYZ))
      DO 10 I=1,NBN
         XX(I) = 0.0
   10 CONTINUE
      IF (R00 .LE. EPSSLV ) THEN
        IF(ITRN.EQ.NCXIT) WRITE(IOUTS,*)
     *   '  Initial residual < EPSSLV;',
     *   ' delta-C = 0 accepted; iterative solver skipped'
        RETURN
      ENDIF
      DO 20 IB=1,NBN
         WORK(IB) = 0.0
         DO 15 J=1,10
            RA(J,IB) = 0.0
   15    CONTINUE
   20 CONTINUE
C.....Multiply the 2 off-diagonal blocks,
C.....     subract from the black diagonal and factor
C.....     the result, RA
      CALL FORMR(VA,VAD,RA,CI,NBN,NRN)
      CALL RFACTM(RA,CIR,CIRH,NBN,WORK)
C.....Divide the red right hand side, RHS_r, by diagonal, D_r
      DO 700 I=1,NRN
         RHS(I) = RHS(I)/VAD(I)
  700 CONTINUE
C.....Form the RHS of the reduced system
      NRNP1 = NRN+1
      CALL ARMULT(VA,RHS(1),WW,CI,NBN,NRN)
      CALL VPSV(RHS(NRNP1),RHS(NRNP1),WW,-1.0,NBN)
C.....The right hand side is now stored in the bottom half of RHS
C.....Form the initial residual
      CALL ABMULT(VA,VAD,XX,RR,CI,NRN)
      CALL ARMULT(VA,RR,WW,CI,NBN,NRN)
      CALL DBMULT(VAD,XX,RR,NBN,NRN)
      CALL VPSV(WW,RR,WW,-1.0,NBN)
C.....WW now has R*X_black
      CALL VPSV(RR,RHS(NRNP1),WW,-1.0,NBN)
C.....Form the initial search direction
      ICOUNT = 0
  799 CONTINUE
      CALL LSOLV(RA,RR,WW,CIR,CIRL,NBN)
      CALL USOLV(RA,WW,PP,CIR,CIRH,NBN)
      ICOUNT = ICOUNT+1
      IF(ICOUNT.GT.MAXIT) GO TO 999
      CALL ABMULT(VA,VAD,PP,AP,CI,NRN)
      CALL ARMULT(VA,AP,WW,CI,NBN,NRN)
      CALL DBMULT(VAD,PP,AP,NBN,NRN)
      CALL VPSV(AP,AP,WW,-1.0,NBN)
      DELTA = XIP(PP,AP,NBN)
      ALPHA = XIP(PP,RR,NBN)/DELTA
C.....  Update the solution
      CALL VPSV(XX,XX,PP,ALPHA,NBN)
C.....  Update the residual
      CALL VPSV(RR,RR,AP,-ALPHA,NBN)
      R1 = SQRT(XIP(RR,RR,NBN))
      RAT=R1/R00
C..        WRITE(FUCLOG,*) 'i, current relative residual: ', ICOUNT, RAT
C..        WRITE(FUCLOG,*) 'current residual: ', R1
      IF (RAT.LE.EPSSLV) GOTO 1010
      CALL LSOLV(RA,RR,WW,CIR,CIRL,NBN)
      CALL USOLV(RA,WW,SS,CIR,CIRH,NBN)
      H = XIP(SS,AP,NBN)/DELTA
      CALL VPSV(PP,SS,PP,-H,NBN)
 1000 CONTINUE
      GO TO 799
  999 CONTINUE
      WRITE(IOUTS,9002) '****ERROR****   Conjugate-gradient solver ',
     X     'reached maximum iterations: ',MAXIT
      WRITE(IOUTS,9003) ICOUNT, RAT
      WRITE(IOUTS,*)
      WRITE(IOUTS,*) 'If residual is acceptable, increase EPSSLV'
      WRITE(IOUTS,*) 'If residual is unacceptable, increase MAXIT'
      STOP
 9002 FORMAT(/TR10,2A,I5)
 1010 CONTINUE
      IF(ITRN.EQ.NCXIT) WRITE(IOUTS,9003) ICOUNT, RAT
 9003 FORMAT('  No. of solver iterations = ',I4,' Relative residual = ',
     *1pE12.4)
c      IF(ICOUNT.EQ.1)
c     *  WRITE(IOUTS,*) '***WARNING***   Number of iterations = 1;',
c     *  '    Suggest decreasing EPSSLV'
C.....Form the red solution from the black half
      CALL ABMULT(VA,VAD,XX,WW,CI,NRN)
      CALL VPSV(RHS(1),RHS(1),WW,-1.0,NRN)
C.....Set rhs_black equal to x_black
      CALL VPSV(RHS(NRNP1),XX,WW,0.0,NBN)
      RETURN
      END
      SUBROUTINE DBMULT(VAD,Y,X,NBN,NRN)
C.....Multiplies Diag_A*y for the black nodes
c      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
c      DOUBLE PRECISION VAD,X,Y
      INTEGER NBN,NRN
      DIMENSION X(*),Y(*),VAD(*)
C...
      DO 10 I=1,NBN
         J = I+NRN
         X(I) = Y(I)*VAD(J)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE FORMR(VA,VAD,RA,CI,NBN,NRN)
C.....Form the product of the off-diagonal blocks,
C.....Scale and subtract from the black diagonal to get
C.....     the reduced matrix, RA.
c      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
c      DOUBLE PRECISION VA,VAD,RA,DD
      INTEGER NBN,NRN,CI
      DIMENSION VA(6,*),VAD(*),RA(10,*),CI(6,*)
      COMMON/CAIS/MAR(6,6),MAR1(19,19)
C...    
      DO 1 K=1,NBN
         RA(10,K) = VAD(K+NRN)
    1 CONTINUE
      DO 10 K=1,NRN
         DO 5 IC=1,6
            IROW = CI(IC,K)
            IF (IROW.GT.0) THEN
               DD = VA(IC,K)
               NROW = IROW-NRN
               DO 20 J=1,IC
                  IF (CI(J,K).GT.0) 
     X     RA(MAR(IC,J),NROW) = RA(MAR(IC,J),NROW)-DD*VA(J,K)/VAD(K)
   20          CONTINUE
            ENDIF
    5    CONTINUE
   10 CONTINUE
      RETURN
      END
      SUBROUTINE LSOLV(RA,RR,WW,CIR,CIRL,NBN)
C.....Solves the lower triangular matrix equation, L*ww=rr
C.....     for the black-node equations
c      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
c      DOUBLE PRECISION RA,RR,WW,S
      INTEGER CIRL,CIR
      DIMENSION RR(*),WW(*),RA(10,*),CIRL(10,*),CIR(19,*)
C...
      WW(1) = RR(1)
      DO 10 K=2,NBN
         S = RR(K)
         DO 5 JJ=1,CIRL(1,K)
            J = CIRL(JJ+1,K)
            JCOL = CIR(J,K)
            S = S-RA(J,K)*WW(JCOL)
    5    CONTINUE
         WW(K) = S
   10 CONTINUE
      RETURN
      END
      SUBROUTINE RFACTM(RA,CIR,CIRH,NBN,WORK)
C.....Factors the reduced matrix, RA, to modified incomplete LDL^T factors
c      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
c      DOUBLE PRECISION RA,WORK,DD
      INTEGER CIR,CIRH,NBN
      DIMENSION RA(10,*),CIR(19,*),CIRH(10,*),WORK(*)
      COMMON/CAIS/MAR(6,6),MAR1(19,19)
C...
      DO 30 K=1,NBN-1
         RA(10,K) = RA(10,K)+WORK(K)
         DO 20 II=1,CIRH(1,K)
            I = CIRH(II+1,K)
            IROW = CIR(I,K)
            DD = RA(MAR1(I,10),IROW)/RA(10,K)
            RA(MAR1(I,10),IROW) = DD
            DO 10 JJ=1,II
               J = CIRH(JJ+1,K)
               JROW = CIR(J,K)
               L = MAR1(I,J)
               IF (L .EQ. 0) THEN
                  WORK(IROW) = WORK(IROW)-DD*RA(10,K)*RA(20-J,JROW)
                  RA(10,JROW) = RA(10,JROW)-DD*RA(10,K)*RA(20-J,JROW)
C             WRITE(*,*) WORK(IROW)
                  GO TO 10
               END IF
               RA(L,IROW) = RA(L,IROW)-DD*RA(10,K)*RA(20-J,JROW)
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
      RA(10,NBN) = RA(10,NBN)+WORK(NBN)
      RETURN
      END
      SUBROUTINE USOLV(RA,WW,YY,CIR,CIRH,NBN)
C.....Solves the upper triangular matrix equation, U*yy=ww
C.....     for the black-node equations
c      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
c      DOUBLE PRECISION RA,WW,YY,S
      INTEGER CIRH,CIR
      DIMENSION YY(*),WW(*),RA(10,*),CIRH(10,*),CIR(19,*)
C...
      YY(NBN) = WW(NBN)/RA(10,NBN)
      DO 1000 K=NBN-1,1,-1
         S = WW(K)/RA(10,K)
         DO 500 JJ=1,CIRH(1,K)
            J = CIRH(JJ+1,K)
            JCOL = CIR(J,K)
            S = S-RA(20-J,JCOL)*YY(JCOL)
  500    CONTINUE 
         YY(K) = S
 1000 CONTINUE
      RETURN
      END
      SUBROUTINE VPSV(X,Y,Z,S,N)
C.....Calculates a vector plus a scalar times a vector
C.....     x=y+s*z
c      DOUBLE PRECISION X,Y,Z,S
      INTEGER N
      DIMENSION X(*),Y(*),Z(*)
C...
      DO 10 I=1,N
        X(I) = Y(I)+S*Z(I)
10    CONTINUE
      RETURN
      END
      FUNCTION XIP(X,Y,N)
C.....Forms the inner or dot product of two vectors
c      DOUBLE PRECISION XIP,X,Y
      INTEGER N
      DIMENSION X(*),Y(*)
C...
      XIP = 0.0
      DO 10 I=1,N
        XIP = XIP+X(I)*Y(I)
10    CONTINUE
      RETURN
      END
