C  DSP6   DISPERSION
C
C  DSP6FM  DISPERSION COEFFICIENTS
C***********************************************
C
      SUBROUTINE DSP6FM(DISPCC,
     *  DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,DISPLL,
     *  DISPLC,DISPLR,THCK,ALONG,ATRANH,ATRANV,
     *  POR,RF,VC,VR,VL,IBOUND,MOCTYPE,
     *  DELT,NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     *  IOUTS,NTIMD,TIMDC,NODISP,DIFFUS,
cellam
     *  DELCOL,DELROW)
cellam
C
C FOR ELLAM, MODIFIED TO
C  - YIELD CORRECT CELL DIMENSION IN DENOMINATOR
C  - HANDLE NONUNIFORM GRID.
C  THIS VERSION RETAINS MOC3D APPROXIMATION IGNORING VARIABLE
C  CELL THICKNESS IN DENOMINATOR
C***********************************************
C
      DIMENSION
     *  DISPCC(NSCOL,NSROW,NSLAY),DISPCR(NSCOL,NSROW,NSLAY),
     *  DISPCL(NSCOL,NSROW,NSLAY),DISPRR(NSCOL,NSROW,NSLAY),
     *  DISPRC(NSCOL,NSROW,NSLAY),DISPRL(NSCOL,NSROW,NSLAY),
     *  DISPLL(NSCOL,NSROW,NSLAY),DISPLC(NSCOL,NSROW,NSLAY),
     *  DISPLR(NSCOL,NSROW,NSLAY),THCK(NSCOL,NSROW,NSLAY),
     *  ALONG(NSLAY),ATRANH(NSLAY),ATRANV(NSLAY),
     *  POR(NSCOL,NSROW,NSLAY),RF(NSCOL,NSROW,NSLAY),
     *  VC(NSCOL+1,NSROW,NSLAY),VR(NSCOL,NSROW+1,NSLAY),
     *  VL(NSCOL,NSROW,NSLAY+1),IBOUND(NCOL,NROW,NLAY)
C
cellam
      DIMENSION DELCOL(NCOL),DELROW(NROW)
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
cellam
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C  BUFF HOLDS AVG CONC; DSP BY FACE, NOT BLOCK
C  INDEXING FOR VELOCITY VX(IXV, ,) IS FLOW FROM IXV-1 TO IXV
C
C     ***************************************************************
C
C     ---COMPUTE DISPERSION COEFFICIENTS---
C  SPATIAL TERMS IN HORIZONTAL DIRECTIONS
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
       DCINV=1.D0/CDEL
       CC2INV=DCINV*DCINV
       DRINV=1.D0/RDEL
       RR2INV=DRINV*DRINV
       CR2INV=0.25D0*DCINV*DRINV
       ARINV=DCINV*DRINV
      ENDIF
cellam
C
C  VERTICAL DIMENSION DEPENDS ON CELLS
C
C*****************************************
C
C  BEGIN LOOP FOR DISPERSION COEFFICIENTS
C
C*****************************************
C
      DO 60 KS=1,NSLAY
      KSV1=KS
      KSV2=KS+1
      K=KS+ISLAY1-1
C  DISPERSIVITIES FOR THIS LAYER
      IF(NODISP.NE.1) THEN
         ALONGL=ALONG(KS)
         ATRNH=ATRANH(KS)
         ATRNV=ATRANV(KS)
C  TAKE HARMONIC MEAN OF DISPERSIVITIES FOR BETWEEN LAYERS
         IF(KS.LT.NSLAY) THEN
            IF(ALONGL.EQ.0.0.OR.ALONG(KS+1).EQ.0.0) THEN
               ALONGV=0.0D0
            ELSE
               ALONGV=2.D0*ALONGL*ALONG(KS+1)/(ALONGL+ALONG(KS+1))
            END IF
            IF(ATRNV.EQ.0.0.OR.ATRANV(KS+1).EQ.0.0) THEN
               ATRNVV=0.0D0
            ELSE
               ATRNVV=2.D0*ATRNV*ATRANV(KS+1)/(ATRNV+ATRANV(KS+1))
            END IF
         END IF
      END IF
      DO 60 IS=1,NSROW
      ISV1=IS
      ISV2=IS+1
      I=IS+ISROW1-1
cellam
      IF(MOCTYPE.EQ.3) THEN
        DIINV=1.D0/DELROW(I)
        R4INV=0.25D0*DIINV
      END IF
cellam
      DO 60 JS=1,NSCOL
      JSV1=JS
      JSV2=JS+1
      J=JS+ISCOL1-1
C  INITIALIZE DISPERSION COEFFICIENTS TO ZERO
      DISPCC(JS,IS,KS)=0.0D0
      DISPRR(JS,IS,KS)=0.0D0
      DISPLL(JS,IS,KS)=0.0D0
      IF(NODISP.NE.1) THEN
         DISPCR(JS,IS,KS)=0.0D0
         DISPRC(JS,IS,KS)=0.0D0
         DISPCL(JS,IS,KS)=0.0D0
         DISPRL(JS,IS,KS)=0.0D0
         DISPLC(JS,IS,KS)=0.0D0
         DISPLR(JS,IS,KS)=0.0D0
      END IF
C
C  SKIP REST IF INACTIVE CELL
      IF(IBOUND(J,I,K).EQ.0) GO TO 60
C
      THCKNS=THCK(JS,IS,KS)
      PORB1=THCKNS*POR(JS,IS,KS)
C  COMPUTE DELTA Z (L) AT KS+1/2 FROM CELL THICKNESSES
C   AND SET SPATIAL TERMS FOR DISP COEFFICIENTS
      IF(KS.LT.NSLAY) THEN
         DELINV=2.D0/(THCKNS+THCK(JS,IS,KS+1))
cellam
         IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
           DL2INV=DELINV*DELINV
           CL2INV=0.25D0*DCINV*DELINV
           RL2INV=0.25D0*DRINV*DELINV
         ELSEIF(MOCTYPE.EQ.3) THEN
           L4INV=0.25D0*DELINV
         END IF
cellam
      END IF
C        ---FORWARD COEFFICIENTS: COL-DIRECTION---
C  SKIP IF THIS IS LAST SOLUTE TRANSPORT COLUMN, NO DISPERSION
C   ACROSS SUBGRID BOUNDARY, OR IF CELL IN NEXT COLUMN IS INACTIVE
cellam
      IF(MOCTYPE.EQ.3) THEN
        DJINV=1.D0/DELCOL(J)
        C4INV=0.25D0*DJINV
      END IF
cellam
      IF(JS.EQ.NSCOL) GO TO 20
cellam
      IF(MOCTYPE.EQ.3) THEN
        DCINV=2.D0/(DELCOL(J)+DELCOL(J+1))
        DJ1INV=1.D0/DELCOL(J+1)
      END IF
cellam
      IF(IBOUND(J+1,I,K).EQ.0) GO TO 20
C  IF DIFFUSION ONLY, SET TERM AND SKIP TO ROW TERMS
C
C  MOLECULAR DIFFUSION COEFFICIENT INCLUDES TORTUOSITY
C   HAS SAME UNITS AS (ALPHA)V, MULTIPLY BY POROSITY LIKE SUTRA
C   ALSO MULTIPLY BY THICKNESS FOR HORIZONTAL TERMS USING
C   HARMONIC MEAN INTERBLOCK VALUE
      IF(DIFFUS.NE.0.0) THEN
cellam
         IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
           PORB2=POR(JS+1,IS,KS)*THCK(JS+1,IS,KS)
           DISPCC(JS,IS,KS)=DIFFUS*2.D0*PORB1*PORB2/
     *                    (PORB1+PORB2)*CC2INV
         ELSEIF(MOCTYPE.EQ.3) THEN
           PORB2=POR(JS+1,IS,KS)*THCK(JS+1,IS,KS)
           DISPCC(JS,IS,KS)=DIFFUS*2.D0*PORB1*PORB2/
     *                    (PORB1+PORB2)*DCINV
         ENDIF
cellam
      END IF
      IF(NODISP.EQ.1) GO TO 20
C  COMPUTE VELOCITY COMPONENTS AT (J+1/2,I,K)
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
        VC2=VC(JSV2,IS,KS)*DRINV
        VC22=VC2*VC2
C  BINLINEAR INTERPOLATION FOR VR AND VL
        VRC2=(VR(JS,ISV1,KS)+VR(JS+1,ISV1,KS)+
     *      VR(JS,ISV2,KS)+VR(JS+1,ISV2,KS))*0.25D0*DCINV
        VRC22=VRC2*VRC2
        VLC2=(VL(JS,IS,KSV1)+VL(JS+1,IS,KSV1)+
     *      VL(JS,IS,KSV2)+VL(JS+1,IS,KSV2))*0.25D0*THCKNS*ARINV
        VLC22=VLC2*VLC2
      ELSEIF(MOCTYPE.EQ.3) THEN
        VC2=VC(JSV2,IS,KS)*DIINV
        VC22=VC2*VC2
C  BINLINEAR INTERPOLATION FOR VR AND VL
        VRC2=(VR(JS,ISV1,KS)+VR(JS,ISV2,KS))*0.25D0*DJINV+
     *     (VR(JS+1,ISV1,KS)+VR(JS+1,ISV2,KS))*0.25D0*DJ1INV
        VRC22=VRC2*VRC2
        VLC2=((VL(JS,IS,KSV1)+VL(JS,IS,KSV2))*DJINV+
     *  (VL(JS+1,IS,KSV1)+VL(JS+1,IS,KSV2))*DJ1INV)*0.25D0*THCKNS*DIINV
        VLC22=VLC2*VLC2
      ENDIF
cellam
C  MAGNITUDE OF VELOCITY AT (J+1/2,I,K)
      VMGC22=VC22+VRC22+VLC22
      VMGC2=SQRT(VMGC22)
C  SKIP IF VELOCITY IS MACHINE ZERO
      IF(VMGC2.LT.1.0E-20) GO TO 20
C
C           ---CC COEFFICIENT---
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
        DISPCC(JS,IS,KS)=DISPCC(JS,IS,KS)+
     *         (ALONGL*VC22+ATRNH*VRC22+ATRNV*VLC22)/VMGC2*CC2INV
      ELSEIF(MOCTYPE.EQ.3) THEN
        DISPCC(JS,IS,KS)=DISPCC(JS,IS,KS)+
     *         (ALONGL*VC22+ATRNH*VRC22+ATRNV*VLC22)/VMGC2*DCINV
      ENDIF
cellam
C  SKIP IF FIRST OR LAST ROW IN SUBGRID
      IF(IS.EQ.1.OR.IS.EQ.NSROW) GO TO 10
C           ---CR COEFFICIENT---
C  SKIP IF ANY OF CELLS USED FOR D(CONC)/DR ARE INACTIVE
C   SKIP TO ROW IF DISPERSIVITIES ARE EQUAL (NO CROSS TERMS)
      IF(IBOUND(J,I-1,K).EQ.0.OR.IBOUND(J+1,I-1,K).EQ.0.OR.
     *   IBOUND(J,I+1,K).EQ.0.OR.IBOUND(J+1,I+1,K).EQ.0.OR.
     *   ALONGL.EQ.ATRNH)
     *    GO TO 10
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
        DISPCR(JS,IS,KS)=(ALONGL-ATRNH)*VC2*VRC2/VMGC2*CR2INV
      ELSEIF(MOCTYPE.EQ.3) THEN
        DISPCR(JS,IS,KS)=(ALONGL-ATRNH)*VC2*VRC2/VMGC2*R4INV
      ENDIF
cellam
C           ---CL COEFFICIENT---
C  SKIP IF FIRST OR LAST LAYER IN SUBGRID
   10 IF(KS.EQ.1.OR.KS.EQ.NSLAY) GO TO 20
C  SKIP IF ANY OF CELLS USED FOR D(CONC)/DL ARE INACTIVE
      IF(IBOUND(J,I,K-1).EQ.0.OR.IBOUND(J+1,I,K-1).EQ.0.OR.
     *   IBOUND(J,I,K+1).EQ.0.OR.IBOUND(J+1,I,K+1).EQ.0.OR.
     *   ALONGL.EQ.ATRNV)
     *    GO TO 20
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
        DISPCL(JS,IS,KS)=(ALONGL-ATRNV)*VC2*VLC2/VMGC2*CL2INV
      ELSEIF(MOCTYPE.EQ.3) THEN
        DISPCL(JS,IS,KS)=(ALONGL-ATRNV)*VC2*VLC2/VMGC2*L4INV
      ENDIF
cellam
C        ---FORWARD COEFFICIENTS: ROW-DIRECTION---
   20 CONTINUE
cellam
      IF(MOCTYPE.EQ.3) ARINV=DJINV*DIINV
cellam
      IF(IS.EQ.NSROW) GO TO 40
cellam
      IF(MOCTYPE.EQ.3) THEN
        DRINV=2.D0/(DELROW(I)+DELROW(I+1))
        DI1INV=1.D0/DELROW(I+1)
      END IF
cellam
      IF(IBOUND(J,I+1,K).EQ.0) GO TO 40
      IF(DIFFUS.NE.0.0) THEN
cellam
        IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
          PORB2=POR(JS,IS+1,KS)*THCK(JS,IS+1,KS)
          DISPRR(JS,IS,KS)=DIFFUS*2.D0*PORB1*PORB2/
     *                    (PORB1+PORB2)*RR2INV
        ELSEIF(MOCTYPE.EQ.3) THEN
          PORB2=POR(JS,IS+1,KS)*THCK(JS,IS+1,KS)
          DISPRR(JS,IS,KS)=DIFFUS*2.D0*PORB1*PORB2/
     *                    (PORB1+PORB2)*DRINV
        END IF
cellam
      END IF
      IF(NODISP.EQ.1) GO TO 40
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
        VR2=VR(JS,ISV2,KS)*DCINV
        VR22=VR2*VR2
        VCR2=(VC(JSV1,IS,KS)+VC(JSV1,IS+1,KS)+
     *      VC(JSV2,IS,KS)+VC(JSV2,IS+1,KS))*0.25*DRINV
        VCR22=VCR2*VCR2
        VLR2=(VL(JS,IS,KSV1)+VL(JS,IS+1,KSV1)+
     *      VL(JS,IS,KSV2)+VL(JS,IS+1,KSV2))*0.25*THCKNS*ARINV
        VLR22=VLR2*VLR2
      ELSEIF(MOCTYPE.EQ.3) THEN
        VR2=VR(JS,ISV2,KS)*DJINV
        VR22=VR2*VR2
        VCR2=(VC(JSV1,IS,KS)+VC(JSV2,IS,KS))*0.25D0*DIINV+
     *     (VC(JSV1,IS+1,KS)+VC(JSV2,IS+1,KS))*0.25D0*DI1INV
        VCR22=VCR2*VCR2
        DOVC=THCKNS*DJINV
        VLR2=(VL(JS,IS,KSV1)+VL(JS,IS,KSV2))*0.25D0*DOVC*DIINV+
     *     (VL(JS,IS+1,KSV1)+VL(JS,IS+1,KSV2))*0.25D0*DOVC*DI1INV
        VLR22=VLR2*VLR2
      END IF
cellam
      VMGR22=VCR22+VR22+VLR22
      VMGR2=SQRT(VMGR22)
      IF(VMGR2.LT.1.0E-20) GO TO 40
C           ---RR COEFFICIENT---
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN      
        DISPRR(JS,IS,KS)=DISPRR(JS,IS,KS)+
     *         (ALONGL*VR22+ATRNH*VCR22+ATRNV*VLR22)/VMGR2*RR2INV
      ELSEIF(MOCTYPE.EQ.3) THEN
        DISPRR(JS,IS,KS)=DISPRR(JS,IS,KS)+
     *         (ALONGL*VR22+ATRNH*VCR22+ATRNV*VLR22)/VMGR2*DRINV
      ENDIF
cellam
C   SKIP TO LAYER IF DISPERSIVITIES ARE EQUAL (NO CROSS TERMS)
      IF(JS.EQ.1.OR.JS.EQ.NSCOL) GO TO 30
C           ---RC COEFFICIENT---
      IF(IBOUND(J-1,I,K).EQ.0.OR.IBOUND(J-1,I+1,K).EQ.0.OR.
     *   IBOUND(J+1,I,K).EQ.0.OR.IBOUND(J+1,I+1,K).EQ.0.OR.
     *   ALONGL.EQ.ATRNH)
     *    GO TO 30
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN      
        DISPRC(JS,IS,KS)=(ALONGL-ATRNH)*VCR2*VR2/VMGR2*CR2INV
      ELSEIF(MOCTYPE.EQ.3) THEN
        DISPRC(JS,IS,KS)=(ALONGL-ATRNH)*VCR2*VR2/VMGR2*C4INV
      ENDIF
cellam
C           ---RL COEFFICIENT---
   30 IF(KS.EQ.1.OR.KS.EQ.NSLAY) GO TO 40
      IF(IBOUND(J,I,K-1).EQ.0.OR.IBOUND(J,I+1,K-1).EQ.0.OR.
     *   IBOUND(J,I,K+1).EQ.0.OR.IBOUND(J,I+1,K+1).EQ.0.OR.
     *   ALONGL.EQ.ATRNV)
     *    GO TO 40
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN      
        DISPRL(JS,IS,KS)=(ALONGL-ATRNV)*VR2*VLR2/VMGR2*RL2INV
      ELSEIF(MOCTYPE.EQ.3) THEN
        DISPRL(JS,IS,KS)=(ALONGL-ATRNV)*VR2*VLR2/VMGR2*L4INV
      ENDIF
cellam
   40 CONTINUE
C  Z TERMS
C  HERE WE DON'T WANT THICKNESS INCLUDED, BECAUSE MAY VARY BY LAYER
      IF(KS.EQ.NSLAY) GO TO 60
      IF(IBOUND(J,I,K+1).EQ.0) GO TO 60
      IF(DIFFUS.NE.0.0) THEN
cellam
        IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
         DISPLL(JS,IS,KS)=DIFFUS*2.D0*POR(JS,IS,KS)*POR(JS,IS,KS+1)/
     *                    (POR(JS,IS,KS)+POR(JS,IS,KS+1))*DL2INV
        ELSEIF(MOCTYPE.EQ.3) THEN
         DISPLL(JS,IS,KS)=DIFFUS*2.D0*POR(JS,IS,KS)*POR(JS,IS,KS+1)/
     *                    (POR(JS,IS,KS)+POR(JS,IS,KS+1))*DELINV
        END IF
cellam
      END IF
      IF(NODISP.EQ.1) GO TO 60
C
      VL2=VL(JS,IS,KSV2)*ARINV
      VL22=VL2*VL2
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
        VCL2=((VC(JSV1,IS,KS)+VC(JSV2,IS,KS))/THCKNS+
     *      (VC(JSV1,IS,KS+1)+VC(JSV2,IS,KS+1))/THCK(JS,IS,KS+1))
     *      *0.25*DRINV
        VCL22=VCL2*VCL2
        VRL2=((VR(JS,ISV1,KS)+VR(JS,ISV2,KS))/THCKNS+
     *      (VR(JS,ISV1,KS+1)+VR(JS,ISV2,KS+1))/THCK(JS,IS,KS+1))
     *      *0.25*DCINV
      ELSEIF(MOCTYPE.EQ.3) THEN
        VCL2=((VC(JSV1,IS,KS)+VC(JSV2,IS,KS))/THCKNS+
     *      (VC(JSV1,IS,KS+1)+VC(JSV2,IS,KS+1))/THCK(JS,IS,KS+1))
     *      *0.25*DIINV
        VCL22=VCL2*VCL2
        VRL2=((VR(JS,ISV1,KS)+VR(JS,ISV2,KS))/THCKNS+
     *      (VR(JS,ISV1,KS+1)+VR(JS,ISV2,KS+1))/THCK(JS,IS,KS+1))
     *      *0.25*DJINV
      END IF
cellam
      VRL22=VRL2*VRL2
      VMGL22=VCL22+VRL22+VL22
      VMGL2=SQRT(VMGL22)
      IF(VMGL2.LT.1.0E-20) GO TO 60
C           ---LL COEFFICIENT---
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
        DISPLL(JS,IS,KS)=DISPLL(JS,IS,KS)+
     *           (ALONGV*VL22+ATRNVV*(VCL22+VRL22))/VMGL2*DL2INV
      ELSEIF(MOCTYPE.EQ.3) THEN
        DISPLL(JS,IS,KS)=DISPLL(JS,IS,KS)+
     *           (ALONGV*VL22+ATRNVV*(VCL22+VRL22))/VMGL2*DELINV
      END IF
cellam
C   SKIP TO END IF DISPERSIVITIES ARE EQUAL (NO CROSS TERMS)
      IF(ALONGV.EQ.ATRNVV) GO TO 60
      DSPDIF=ALONGV-ATRNVV
C           ---LC COEFFICIENT---
      IF(JS.EQ.1.OR.JS.EQ.NSCOL) GO TO 50
      IF(IBOUND(J-1,I,K).EQ.0.OR.IBOUND(J-1,I,K+1).EQ.0.OR.
     *   IBOUND(J+1,I,K).EQ.0.OR.IBOUND(J+1,I,K+1).EQ.0)
     *    GO TO 50
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
        DISPLC(JS,IS,KS)=DSPDIF*VCL2*VL2/VMGL2*CL2INV
      ELSEIF(MOCTYPE.EQ.3) THEN
        DISPLC(JS,IS,KS)=DSPDIF*VCL2*VL2/VMGL2*C4INV
      END IF
cellam
C           ---LR COEFFICIENT---
   50 IF(IS.EQ.1.OR.IS.EQ.NSROW) GO TO 60
      IF(IBOUND(J,I-1,K).EQ.0.OR.IBOUND(J,I-1,K+1).EQ.0.OR.
     *   IBOUND(J,I+1,K).EQ.0.OR.IBOUND(J,I+1,K+1).EQ.0)
     *    GO TO 60
cellam
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
        DISPLR(JS,IS,KS)=DSPDIF*VRL2*VL2/VMGL2*RL2INV
      ELSEIF(MOCTYPE.EQ.3) THEN
        DISPLR(JS,IS,KS)=DSPDIF*VRL2*VL2/VMGL2*R4INV
      END IF
cellam
C
   60 CONTINUE
C
C*****************************************
C
C  END LOOP FOR DISPERSION COEFFICIENTS
C
C*****************************************
C
      if (MOCTYPE.ne.1) return
C
C     ****************************************************************
C     ---CHECK FOR STABILITY OF EXPLICIT METHOD---
C     ****************************************************************
C
      TIMDIS=1.E-20
      DO 70 KS=1,NSLAY
      K=KS+ISLAY1-1
      DO 70 IS=1,NSROW
      I=IS+ISROW1-1
      DO 70 JS=1,NSCOL
      J=JS+ISCOL1-1
      IF(IBOUND(J,I,K).EQ.0) GO TO 70
      IF(JS.EQ.1) THEN
         DISPC=DISPCC(JS,IS,KS)
      ELSE
         DISPC=MAX(DISPCC(JS,IS,KS),DISPCC(JS-1,IS,KS))
      END IF
      IF(IS.EQ.1) THEN
       DISPR=DISPRR(JS,IS,KS)
      ELSE
       DISPR=MAX(DISPRR(JS,IS,KS),DISPRR(JS,IS-1,KS))
      END IF
      IF(KS.EQ.1) THEN
       DISPL=DISPLL(JS,IS,KS)
      ELSE
       DISPL=MAX(DISPLL(JS,IS,KS),DISPLL(JS,IS,KS-1))
      END IF
      TDCO=((DISPC+DISPR)/THCK(JS,IS,KS)+DISPL)/
     *    (POR(JS,IS,KS)*RF(js,is,KS))
      IF(TDCO.GT.TIMDIS) TIMDIS=TDCO
   70 CONTINUE
      TIMDC=0.5/TIMDIS
C  CHECK STABILITY 
      NTIMD=DELT/TIMDC
      NTIMD=NTIMD+1
      RETURN
      END
C********************************************************
C
      SUBROUTINE DSP6AP(
     *  DISPCC,DISPCR,DISPCL,
     *  DISPRR,DISPRC,DISPRL,
     *  DISPLL,DISPLC,DISPLR,
     *  THCK,POR,RF,CONC,CNCNC,
     *  IBOUND,CAVG,
     *  NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     *  IOUTS,KSTP,KPER,IMOV,TIMV,
     *  NODISP)
C
C********************************************************
C
C  CHANGES CONCENTRATIONS DUE TO DISPERSION AND SOURCES FOR ONE STEP ONLY
C  COMPUTE EXPLICIT CHANGE IN NODE CONC FOR FULL TIME STEP
CLMT  LIMIT CROSS PRODUCT TERMS
CLMT  CHECK FOR NEGATIVE CONCS IN ADJACENT CELLS
CFWD  COMPUTE BY FACE INSTEAD OF BY BLOCK
C
      DIMENSION
     *  DISPCC(NSCOL,NSROW,NSLAY),DISPCR(NSCOL,NSROW,NSLAY),
     *  DISPCL(NSCOL,NSROW,NSLAY),DISPRR(NSCOL,NSROW,NSLAY),
     *  DISPRC(NSCOL,NSROW,NSLAY),DISPRL(NSCOL,NSROW,NSLAY),
     *  DISPLL(NSCOL,NSROW,NSLAY),DISPLC(NSCOL,NSROW,NSLAY),
     *  DISPLR(NSCOL,NSROW,NSLAY),  THCK(NSCOL,NSROW,NSLAY),
     *     POR(NSCOL,NSROW,NSLAY),    RF(NSCOL,NSROW,NSLAY),
     *    CONC(NSCOL,NSROW,NSLAY), CNCNC(NSCOL,NSROW,NSLAY),
     *  IBOUND(NCOL,NROW,NLAY),CAVG(NSCOL,NSROW,NSLAY)
C
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C     ***************************************************************
C  SKIP TO NODE CONCS IF NO DISP,DIFFUS,OR SINK/SOURCE OR DECAY
C     ***************************************************************
C     ---CONC. CHANGE DUE TO:
      DO 20 KS=1,NSLAY
      K=KS+ISLAY1-1
      DO 20 IS=1,NSROW
      I=IS+ISROW1-1
      DO 20 JS=1,NSCOL
      J=JS+ISCOL1-1
C  SKIP IF INACTIVE CELL
      IF(IBOUND(J,I,K).EQ.0) GO TO 20
C
CFWD  DELTA T / (RF POR THCK) FOR THIS CELL
      TRFPRB=timv/(POR(JS,IS,KS)*THCK(JS,IS,KS)*rf(js,is,ks))
      C2=CAVG(JS,IS,KS)
C         ---CONC. CHANGE DUE TO DISPERSION FOR TIMV---
CLMT  CHECK STABILITY OF TERMS
      CELLMT=-MAX(C2,0.0)/TRFPRB
C        ---DISPERSION WITH TENSOR COEFFICIENTS---
CFM  DISP FLUX IN FORWARD COLUMN DIRECTION
      IF(JS.LT.NSCOL) THEN
      IF(IBOUND(J+1,I,K).NE.0) THEN
         PRBIN2=1.D0/(POR(JS+1,IS,KS)*THCK(JS+1,IS,KS))
CFM  FLUX DUE TO DXX
         DSPXX2=DISPCC(JS,IS,KS)*(CAVG(JS+1,IS,KS)-C2)
         IF(NODISP.NE.1) THEN
CFWD  FLUX DUE TO DXY
            IF(IS.GT.1.AND.IS.LT.NSROW)
     *        DSPXX2=DSPXX2+DISPCR(JS,IS,KS)*
     *         (CAVG(JS,IS+1,KS)+CAVG(JS+1,IS+1,KS)
     *         -CAVG(JS,IS-1,KS)-CAVG(JS+1,IS-1,KS))
CFWD  FLUX DUE TO DXZ
            IF(KS.GT.1.AND.KS.LT.NSLAY)
     *        DSPXX2=DSPXX2+DISPCL(JS,IS,KS)*
     *         (CAVG(JS,IS,KS+1)+CAVG(JS+1,IS,KS+1)
     *         -CAVG(JS,IS,KS-1)-CAVG(JS+1,IS,KS-1))
CFWD  LIMIT
            IF(DSPXX2.LT.0.0) THEN
               IF(DSPXX2.LT.CELLMT) DSPXX2=CELLMT
            ELSE IF(DSPXX2.GT.0.0) THEN
               ADJLMT=MAX(CONC(JS+1,IS,KS),0.0)/
     *           (timv*PRBIN2/rf(js+1,is,ks))
               IF(DSPXX2.GT.ADJLMT) DSPXX2=ADJLMT
            END IF
         END IF
CFM  ADD FLUX TO FORWARD ADJACENT BLOCK
         CNCNC(JS,IS,KS)=CNCNC(JS,IS,KS)+DSPXX2*TRFPRB
         CNCNC(JS+1,IS,KS)=CNCNC(JS+1,IS,KS)-DSPXX2*timv*PRBIN2/
     *     rf(js+1,is,ks)
      END IF
      END IF
C
CFM  DISP FLUX IN FORWARD ROW DIRECTION
      IF(IS.LT.NSROW) THEN
      IF(IBOUND(J,I+1,K).NE.0) THEN
        tPRBIN2=timv/(POR(JS,IS+1,KS)*THCK(JS,IS+1,KS)*rf(js,is+1,ks))
         DSPYY2=DISPRR(JS,IS,KS)*(CAVG(JS,IS+1,KS)-C2)
         IF(NODISP.NE.1) THEN
            IF(JS.GT.1.AND.JS.LT.NSCOL)
     *        DSPYY2=DSPYY2+DISPRC(JS,IS,KS)*
     *         (CAVG(JS+1,IS,KS)+CAVG(JS+1,IS+1,KS)
     *         -CAVG(JS-1,IS,KS)-CAVG(JS-1,IS+1,KS))
            IF(KS.GT.1.AND.KS.LT.NSLAY)
     *        DSPYY2=DSPYY2+DISPRL(JS,IS,KS)*
     *         (CAVG(JS,IS,KS+1)+CAVG(JS,IS+1,KS+1)
     *         -CAVG(JS,IS,KS-1)-CAVG(JS,IS+1,KS-1))
            IF(DSPYY2.LT.0.0) THEN
               IF(DSPYY2.LT.CELLMT) DSPYY2=CELLMT
            ELSE IF(DSPYY2.GT.0.0) THEN
               ADJLMT=MAX(CONC(JS,IS+1,KS),0.0)/tPRBIN2
               IF(DSPYY2.GT.ADJLMT) DSPYY2=ADJLMT
            END IF
         END IF
         CNCNC(JS,IS,KS)=CNCNC(JS,IS,KS)+DSPYY2*TRFPRB
         CNCNC(JS,IS+1,KS)=CNCNC(JS,IS+1,KS)-DSPYY2*tPRBIN2
      END IF
      END IF
CFM  Z TERM
CFM  THIS VERSION IGNORES THICKNESS VARIABILITY WHEN INTERPOLATING
CFM   FOR GRADZ
      IF(KS.LT.NSLAY) THEN
      IF(IBOUND(J,I,K+1).NE.0) THEN
         RFPOR2=1.D0/(RF(js,is,KS+1)*POR(JS,IS,KS+1))
         DSPZZ2=DISPLL(JS,IS,KS)*(CAVG(JS,IS,KS+1)-C2)
         IF(NODISP.NE.1) THEN
            IF(JS.GT.1.AND.JS.LT.NSCOL)
     *        DSPZZ2=DSPZZ2+DISPLC(JS,IS,KS)*
     *         (CAVG(JS+1,IS,KS)+CAVG(JS+1,IS,KS+1)
     *         -CAVG(JS-1,IS,KS)-CAVG(JS-1,IS,KS+1))
            IF(IS.GT.1.AND.IS.LT.NSROW)
     *        DSPZZ2=DSPZZ2+DISPLR(JS,IS,KS)*
     *         (CAVG(JS,IS+1,KS)+CAVG(JS,IS+1,KS+1)
     *         -CAVG(JS,IS-1,KS)-CAVG(JS,IS-1,KS+1))
cgzh causes vertical asymmetry
            IF(DSPZZ2.LT.0.0) THEN
               CELLMT=CELLMT/THCK(JS,IS,KS)
               IF(DSPZZ2.LT.CELLMT) DSPZZ2=CELLMT
            ELSE IF(DSPZZ2.GT.0.0) THEN
               ADJLMT=MAX(CONC(JS,IS,KS+1),0.0)/(TIMV*RFPOR2)
               IF(DSPZZ2.GT.ADJLMT) DSPZZ2=ADJLMT
            END IF
         END IF
         CNCNC(JS,IS,KS)=CNCNC(JS,IS,KS)+DSPZZ2*timv/
     *     (POR(JS,IS,KS)*rf(js,is,ks))
         CNCNC(JS,IS,KS+1)=CNCNC(JS,IS,KS+1)-DSPZZ2*TIMV*RFPOR2
      END IF
      END IF
C
CLMT  LIMIT DISP BY AVAILABLE MASS 
C
C     ****************************************************************
   20 CONTINUE
C     ****************************************************************
      RETURN
C     ****************************************************************
C
      END
C
C********************************************************
C
      SUBROUTINE DSP6APH(
     *  DISPCC,DISPCR,DISPCL,
     *  DISPRR,DISPRC,DISPRL,
     *  DISPLL,DISPLC,DISPLR,
     *  THCK,POR,RF,CONC,CNCNC,
     *  IBOUND,CAVG,LOCHFB,
     *  NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     *  IOUTS,KSTP,KPER,IMOV,TIMV,
     *  NODISP)
C
C  SPECIAL SUBROUTINE TO CALC DISP WHEN USING HFB PACKAGE
cgzh 06/02/2000 modified from dsp6ap
C********************************************************
C
C  CHANGES CONCENTRATIONS DUE TO DISPERSION AND SOURCES FOR ONE STEP ONLY
C  COMPUTE EXPLICIT CHANGE IN NODE CONC FOR FULL TIME STEP
CLMT  LIMIT CROSS PRODUCT TERMS
CLMT  CHECK FOR NEGATIVE CONCS IN ADJACENT CELLS
CFWD  COMPUTE BY FACE INSTEAD OF BY BLOCK
C
      DIMENSION
     *  DISPCC(NSCOL,NSROW,NSLAY),DISPCR(NSCOL,NSROW,NSLAY),
     *  DISPCL(NSCOL,NSROW,NSLAY),DISPRR(NSCOL,NSROW,NSLAY),
     *  DISPRC(NSCOL,NSROW,NSLAY),DISPRL(NSCOL,NSROW,NSLAY),
     *  DISPLL(NSCOL,NSROW,NSLAY),DISPLC(NSCOL,NSROW,NSLAY),
     *  DISPLR(NSCOL,NSROW,NSLAY),  THCK(NSCOL,NSROW,NSLAY),
     *     POR(NSCOL,NSROW,NSLAY),    RF(NSCOL,NSROW,NSLAY),
     *    CONC(NSCOL,NSROW,NSLAY), CNCNC(NSCOL,NSROW,NSLAY),
     *  IBOUND(NCOL,NROW,NLAY),CAVG(NSCOL,NSROW,NSLAY),
     *  LOCHFB(NSCOL,NSROW,NSLAY,2)
C
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C     ***************************************************************
C  SKIP TO NODE CONCS IF NO DISP,DIFFUS,OR SINK/SOURCE OR DECAY
C     ***************************************************************
C     ---CONC. CHANGE DUE TO:
      DO 20 KS=1,NSLAY
      K=KS+ISLAY1-1
      DO 20 IS=1,NSROW
      I=IS+ISROW1-1
      DO 20 JS=1,NSCOL
      J=JS+ISCOL1-1
C  SKIP IF INACTIVE CELL
      IF(IBOUND(J,I,K).EQ.0) GO TO 20
C
CFWD  DELTA T / (RF POR THCK) FOR THIS CELL
      TRFPRB=timv/(POR(JS,IS,KS)*THCK(JS,IS,KS)*rf(js,is,ks))
      C2=CAVG(JS,IS,KS)
cgzh define C for cells around node in question
cgzh for current layer, relative to C2 which is at JS,IS,KS:
c
c         C11  C12
c    C20 (C2)  C22
c    C30  C31  C32
c
cgzh for layer above (k-1)
c
c         C41  C42
c    C50 (C2)  C52
c    C60  C61  C62
c
cgzh for layer below (k+1)
c
c         C71  C72
c    C80 (C2)  C82
c    C90  C91  C92
c
cgzh
C         ---CONC. CHANGE DUE TO DISPERSION FOR TIMV---
CLMT  CHECK STABILITY OF TERMS
      CELLMT=-MAX(C2,0.0)/TRFPRB
C        ---DISPERSION WITH TENSOR COEFFICIENTS---
CFM  DISP FLUX IN FORWARD COLUMN DIRECTION
      IF(JS.LT.NSCOL) THEN
      IF(IBOUND(J+1,I,K).NE.0) THEN
         PRBIN2=1.D0/(POR(JS+1,IS,KS)*THCK(JS+1,IS,KS))
CFM  FLUX DUE TO DXX
         DSPXX2=DISPCC(JS,IS,KS)*(CAVG(JS+1,IS,KS)-C2)
         IF(NODISP.NE.1) THEN
CFWD  FLUX DUE TO DXY
            IF(IS.GT.1.AND.IS.LT.NSROW) THEN
cgzh if dispcr=0, skip redefinition of cavg terms (product=0 anyway)
cgzh if not, check two cells above, if either hfb then use current row + alter length
cgzh then check two cells below, if either hfb then use current row + alter length
cgzh if both, grad should=0 
C   LOCHFB(JS,IS,KS,1) for forward column direction (1=true)
C   LOCHFB(JS,IS,KS,2) for forward row direction (1=true)
                        MULT=1.0
                    IF(DISPCR(JS,IS,KS).NE.0.0) THEN
                  C11=CAVG(JS,IS-1,KS)
                  C12=CAVG(JS+1,IS-1,KS)
                C31=CAVG(JS,IS+1,KS)
                  C32=CAVG(JS+1,IS+1,KS)
                  C22=CAVG(JS+1,IS,KS)
                  IF(LOCHFB(JS,IS-1,KS,2).EQ.1.OR.
     *               LOCHFB(JS+1,IS-1,KS,2).EQ.1) THEN
                      C11=C2
                      C12=C22
cgzh         need to account for new delta R here
                                MULT=2.0
                  END IF
                  IF(LOCHFB(JS,IS,KS,2).EQ.1.OR.
     *               LOCHFB(JS+1,IS,KS,2).EQ.1) THEN
                      C31=C2
                      C32=C22
cgzh         need to account for new delta R here
                                MULT=2.0
                  END IF
                        END IF
              DSPXX2=DSPXX2+DISPCR(JS,IS,KS)*MULT*
     *        (C31+C32
     *        -C11-C12)
cgzh orig              DSPXX2=DSPXX2+DISPCR(JS,IS,KS)*
cgzh     *         (CAVG(JS,IS+1,KS)+CAVG(JS+1,IS+1,KS)
cgzh     *         -CAVG(JS,IS-1,KS)-CAVG(JS+1,IS-1,KS))
                  END IF
CFWD  FLUX DUE TO DXZ
            IF(KS.GT.1.AND.KS.LT.NSLAY)
     *        DSPXX2=DSPXX2+DISPCL(JS,IS,KS)*
     *         (CAVG(JS,IS,KS+1)+CAVG(JS+1,IS,KS+1)
     *         -CAVG(JS,IS,KS-1)-CAVG(JS+1,IS,KS-1))
CFWD  LIMIT
            IF(DSPXX2.LT.0.0) THEN
               IF(DSPXX2.LT.CELLMT) DSPXX2=CELLMT
            ELSE IF(DSPXX2.GT.0.0) THEN
               ADJLMT=MAX(CONC(JS+1,IS,KS),0.0)/
     *           (timv*PRBIN2/rf(js+1,is,ks))
               IF(DSPXX2.GT.ADJLMT) DSPXX2=ADJLMT
            END IF
         END IF
CFM  ADD FLUX TO FORWARD ADJACENT BLOCK
         CNCNC(JS,IS,KS)=CNCNC(JS,IS,KS)+DSPXX2*TRFPRB
         CNCNC(JS+1,IS,KS)=CNCNC(JS+1,IS,KS)-DSPXX2*timv*PRBIN2/
     *     rf(js+1,is,ks)
      END IF
      END IF
C
CFM  DISP FLUX IN FORWARD ROW DIRECTION
      IF(IS.LT.NSROW) THEN
      IF(IBOUND(J,I+1,K).NE.0) THEN
         tPRBIN2=timv/(POR(JS,IS+1,KS)*THCK(JS,IS+1,KS)*rf(js,is+1,ks))
         DSPYY2=DISPRR(JS,IS,KS)*(CAVG(JS,IS+1,KS)-C2)
         IF(NODISP.NE.1) THEN
            IF(JS.GT.1.AND.JS.LT.NSCOL) THEN
cgzh if disprc=0, skip redefinition of cavg terms
cgzh if not, check two cells to left, if either hfb then use current col + alter length
cgzh then check two cells to right, if either hfb then use current col + alter l
cgzh if both, grad should=0 anyway
                        MULT=1.0
                    IF(DISPRC(JS,IS,KS).NE.0.0) THEN
                  C22=CAVG(JS+1,IS,KS)
                  C32=CAVG(JS+1,IS+1,KS)
                C20=CAVG(JS-1,IS,KS)
                  C30=CAVG(JS-1,IS+1,KS)
                  C31=CAVG(JS,IS+1,KS)
                  IF(LOCHFB(JS-1,IS,KS,1).EQ.1.OR.
     *               LOCHFB(JS-1,IS+1,KS,1).EQ.1) THEN
                      C20=C2
                      C30=C31
                                MULT=2.0
                  END IF
                  IF(LOCHFB(JS,IS,KS,1).EQ.1.OR.
     *               LOCHFB(JS,IS+1,KS,1).EQ.1) THEN
                      C22=C2
                      C32=C31
                                MULT=2.0
                  END IF
                        END IF
              DSPXX2=DSPXX2+DISPRC(JS,IS,KS)*MULT*
     *        (C22+C32
     *        -C20-C30)
cgzh     *        DSPYY2=DSPYY2+DISPRC(JS,IS,KS)*
cgzh     *         (CAVG(JS+1,IS,KS)+CAVG(JS+1,IS+1,KS)
cgzh     *         -CAVG(JS-1,IS,KS)-CAVG(JS-1,IS+1,KS))
            END IF
                  IF(KS.GT.1.AND.KS.LT.NSLAY)
     *        DSPYY2=DSPYY2+DISPRL(JS,IS,KS)*
     *         (CAVG(JS,IS,KS+1)+CAVG(JS,IS+1,KS+1)
     *         -CAVG(JS,IS,KS-1)-CAVG(JS,IS+1,KS-1))
            IF(DSPYY2.LT.0.0) THEN
               IF(DSPYY2.LT.CELLMT) DSPYY2=CELLMT
            ELSE IF(DSPYY2.GT.0.0) THEN
               ADJLMT=MAX(CONC(JS,IS+1,KS),0.0)/tPRBIN2
               IF(DSPYY2.GT.ADJLMT) DSPYY2=ADJLMT
            END IF
         END IF
         CNCNC(JS,IS,KS)=CNCNC(JS,IS,KS)+DSPYY2*TRFPRB
         CNCNC(JS,IS+1,KS)=CNCNC(JS,IS+1,KS)-DSPYY2*tPRBIN2
      END IF
      END IF
CFM  Z TERM
CFM  THIS VERSION IGNORES THICKNESS VARIABILITY WHEN INTERPOLATING
CFM   FOR GRADZ
      IF(KS.LT.NSLAY) THEN
      IF(IBOUND(J,I,K+1).NE.0) THEN
         RFPOR2=1.D0/(RF(js,is,KS+1)*POR(JS,IS,KS+1))
         DSPZZ2=DISPLL(JS,IS,KS)*(CAVG(JS,IS,KS+1)-C2)
         IF(NODISP.NE.1) THEN
            IF(JS.GT.1.AND.JS.LT.NSCOL) THEN
cgzh if displc=0, skip redefinition of cavg terms
cgzh if not, check two cells to left, if either hfb then use current col + alter length
cgzh then check two cells to right, if either hfb then use current col + alter l
cgzh if both, grad should=0 anyway
                        MULT=1.0
                    IF(DISPLC(JS,IS,KS).NE.0.0) THEN
                    C22=CAVG(JS+1,IS,KS)
                    C82=CAVG(JS+1,IS,KS+1)
                    C20=CAVG(JS-1,IS,KS)
                    C80=CAVG(JS-1,IS,KS+1)
                    C81=CAVG(JS,IS,KS+1)
                  IF(LOCHFB(JS-1,IS,KS,1).EQ.1.OR.
     *               LOCHFB(JS-1,IS,KS+1,1).EQ.1) THEN
                      C20=C2
                      C80=C81
                                MULT=2.0
                  END IF
                  IF(LOCHFB(JS,IS,KS,1).EQ.1.OR.
     *               LOCHFB(JS,IS,KS+1,1).EQ.1) THEN
                      C22=C2
                      C82=C81
                                MULT=2.0
                  END IF
                        END IF
              DSPZZ2=DSPZZ2+DISPLC(JS,IS,KS)*
     *         (C22+C82
     *         -C20-C80)
cgzh     *        DSPZZ2=DSPZZ2+DISPLC(JS,IS,KS)*
cgzh     *         (CAVG(JS+1,IS,KS)+CAVG(JS+1,IS,KS+1)
cgzh     *         -CAVG(JS-1,IS,KS)-CAVG(JS-1,IS,KS+1))
            ENDIF
            IF(IS.GT.1.AND.IS.LT.NSROW) THEN
cgzh if displr=0, skip redefinition of cavg terms
cgzh if not, check two cells to left, if either hfb then use current col + alter length
cgzh then check two cells to right, if either hfb then use current col + alter l
cgzh if both, grad should=0 anyway
                        MULT=1.0
                    IF(DISPLR(JS,IS,KS).NE.0.0) THEN
                    C31=CAVG(JS,IS+1,KS)
                    C91=CAVG(JS,IS+1,KS+1)
                    C11=CAVG(JS,IS-1,KS)
                    C71=CAVG(JS,IS-1,KS+1)
                    C81=CAVG(JS,IS,KS+1)
                  IF(LOCHFB(JS-1,IS,KS,2).EQ.1.OR.
     *               LOCHFB(JS-1,IS,KS+1,2).EQ.1) THEN
                      C31=C2
                      C91=C81
                                MULT=2.0
                  END IF
                  IF(LOCHFB(JS,IS,KS,2).EQ.1.OR.
     *               LOCHFB(JS,IS,KS+1,2).EQ.1) THEN
                      C11=C2
                      C81=C81
                                MULT=2.0
                  END IF
                        END IF
              DSPZZ2=DSPZZ2+DISPLR(JS,IS,KS)*
     *         (C31+C91
     *         -C11-C71)
cgzh     *        DSPZZ2=DSPZZ2+DISPLR(JS,IS,KS)*
cgzh     *         (CAVG(JS,IS+1,KS)+CAVG(JS,IS+1,KS+1)
cgzh     *         -CAVG(JS,IS-1,KS)-CAVG(JS,IS-1,KS+1))
            END IF
cgzh causes vertical asymmetry
            IF(DSPZZ2.LT.0.0) THEN
               CELLMT=CELLMT/THCK(JS,IS,KS)
               IF(DSPZZ2.LT.CELLMT) DSPZZ2=CELLMT
            ELSE IF(DSPZZ2.GT.0.0) THEN
               ADJLMT=MAX(CONC(JS,IS,KS+1),0.0)/(TIMV*RFPOR2)
               IF(DSPZZ2.GT.ADJLMT) DSPZZ2=ADJLMT
            END IF
         END IF
         CNCNC(JS,IS,KS)=CNCNC(JS,IS,KS)+DSPZZ2*timv/
     *     (POR(JS,IS,KS)*rf(js,is,ks))
         CNCNC(JS,IS,KS+1)=CNCNC(JS,IS,KS+1)-DSPZZ2*TIMV*RFPOR2
      END IF
      END IF
C
CLMT  LIMIT DISP BY AVAILABLE MASS 
C
C     ****************************************************************
   20 CONTINUE
C     ****************************************************************
      RETURN
C     ****************************************************************
C
      END
C
C********************************************************
C
      SUBROUTINE CR5DSP(C,DC,
     X     TSXY,TSXZ,TSYX,TSYZ,TSZX,TSZY,
     X     RS,
     X     RHS,CIN,IBC,MRNO,
     X     NX,NY,NZ,NXY,NXYZ,NRN)
C.....Assembles the matrix coefficients and right hand side vector
C.....     for the solute equation
      INTEGER CIN,IBC,MRNO,NX,NY,NZ,NXYZ
      INTEGER CELLNO
      DIMENSION C(*),DC(*),
     X     TSXY(*),TSXZ(*),TSYX(*),TSYZ(*),
     X     TSZX(*),TSZY(*),
     X     RS(*),
     X     RHS(0:*),CIN(6,*),IBC(*),MRNO(*)
C.....Function for cell number
      CELLNO(I,J,K)=(K-1)*NXY+(J-1)*NX+I
C.....Function for updated concentration
      CNP(MM)=C(MM)+DC(MM)
C.....Function for cross derivative dispersive flux term
      CRDF1(XTC,X1P,X2P,X1,X2)=XTC*(X1P+X2P-X1-X2)
C...
      DO 340 M=1,NXYZ
         MA=MRNO(M)
C.....Decode M into I,J,K
         CALL MTOIJK(M,I,J,K,NX,NY)
         MIMJK=CIN(3,M)
         IF(MIMJK.GT.0) THEN
            MIMJPK=CELLNO(I-1,J+1,K)
            MIMJMK=CELLNO(I-1,J-1,K)
            MIMJKP=CELLNO(I-1,J,K+1)
            MIMJKM=CELLNO(I-1,J,K-1)
         ENDIF
         MIPJK=CIN(4,M)
         IF(MIPJK.GT.0) THEN
            MIPJPK=CELLNO(I+1,J+1,K)
            MIPJMK=CELLNO(I+1,J-1,K)
            MIPJKP=CELLNO(I+1,J,K+1)
            MIPJKM=CELLNO(I+1,J,K-1)
         ENDIF
         MIJMK=CIN(2,M)
         MIJPK=CIN(5,M)
         MIJKM=CIN(1,M)
         IF(MIJKM.GT.0) THEN
            MIJMKM=CELLNO(I,J-1,K-1)
            MIJPKM=CELLNO(I,J+1,K-1)
         ENDIF
         MIJKP=CIN(6,M)
         IF(MIJKP.GT.0) THEN
            MIJMKP=CELLNO(I,J-1,K+1)
            MIJPKP=CELLNO(I,J+1,K+1)
         ENDIF
C.....Zero coefficients are used to suppress equation terms that are
C.....     not present due to geometry of boundaries and/or equations
C.....     that are not being solved
C
C.....Calculate explicit cross-derivative dispersive flux terms
         UCROSC=0.
C.....X-direction
         FTXYDP=0.
         FTXYDM=0.
         IF(MIJMK.GT.0.AND.MIJPK.GT.0) THEN
            IF(MIPJK.GT.0) FTXYDP=CRDF1(TSXY(M),CNP(MIPJPK),CNP(MIJPK),
     X           CNP(MIPJMK),CNP(MIJMK))
            IF(MIMJK.GT.0) FTXYDM=CRDF1(TSXY(M-1),CNP(MIJPK),
     X              CNP(MIMJPK),CNP(MIJMK),CNP(MIMJMK))
         ENDIF
         FTXZDP=0.
         FTXZDM=0.
         IF(MIJKM.GT.0.AND.MIJKP.GT.0) THEN
            IF(MIPJK.GT.0) FTXZDP=CRDF1(TSXZ(M),CNP(MIPJKP),CNP(MIJKP),
     X           CNP(MIPJKM),CNP(MIJKM))
            IF(MIMJK.GT.0) FTXZDM=CRDF1(TSXZ(M-1),CNP(MIJKP),
     X                CNP(MIMJKP),CNP(MIJKM),CNP(MIMJKM))
         ENDIF
C.....Y-direction
         FTYXDP=0.
         FTYXDM=0.
         IF(MIMJK.GT.0.AND.MIPJK.GT.0) THEN
            IF(MIJPK.GT.0) FTYXDP=CRDF1(TSYX(M),CNP(MIPJPK),CNP(MIPJK),
     X           CNP(MIMJPK),CNP(MIMJK))
            IF(MIJMK.GT.0) FTYXDM=CRDF1(TSYX(MIJMK),CNP(MIPJK),
     X                CNP(MIPJMK),CNP(MIMJK),CNP(MIMJMK))
         ENDIF
         FTYZDP=0.
         FTYZDM=0.
         IF(MIJKM.GT.0.AND.MIJKP.GT.0) THEN
            IF(MIJPK.GT.0) FTYZDP=CRDF1(TSYZ(M),CNP(MIJPKP),CNP(MIJKP),
     X           CNP(MIJPKM),CNP(MIJKM))
            IF(MIJMK.GT.0) FTYZDM=CRDF1(TSYZ(MIJMK),CNP(MIJKP),
     X                CNP(MIJMKP),CNP(MIJKM),CNP(MIJMKM))
         ENDIF
C.....Z-direction
         FTZXDP=0.
         FTZXDM=0.
         IF(MIMJK.GT.0.AND.MIPJK.GT.0) THEN
            IF(MIJKP.GT.0) FTZXDP=CRDF1(TSZX(M),CNP(MIPJKP),CNP(MIPJK),
     X           CNP(MIMJKP),CNP(MIMJK))
            IF(MIJKM.GT.0) FTZXDM=CRDF1(TSZX(MIJKM),CNP(MIPJK),
     X             CNP(MIPJKM),CNP(MIMJK),CNP(MIMJKM))
         ENDIF
         FTZYDP=0.
         FTZYDM=0.
         IF(MIJMK.GT.0.AND.MIJPK.GT.0) THEN
            IF(MIJKP.GT.0) FTZYDP=CRDF1(TSZY(M),CNP(MIJPKP),CNP(MIJPK),
     X           CNP(MIJMKP),CNP(MIJMK))
            IF(MIJKM.GT.0) FTZYDM=CRDF1(TSZY(MIJKM),CNP(MIJPK),
     X           CNP(MIJPKM),CNP(MIJMK),CNP(MIJMKM))
         ENDIF
         UCROSC=FTXYDP+FTXZDP+FTYXDP+FTYZDP+FTZXDP+
     X        FTZYDP-FTXYDM-FTXZDM-FTYXDM-FTYZDM-FTZXDM-FTZYDM
C.....Right-hand-side
         RHS(MA)=RS(M)+UCROSC
  340 CONTINUE
      RETURN
      END
C
C
C********************************************************
C
      SUBROUTINE CR5DSPH(C,DC,
     X     TSXY,TSXZ,TSYX,TSYZ,TSZX,TSZY,
     X     RS,
     X     RHS,CIN,IBC,MRNO,
     X     NX,NY,NZ,NXY,NXYZ,NRN,
     X     LOCHFB)
c
cgzh FOR HFB CASES
c
C.....Assembles the matrix coefficients and right hand side vector
C.....     for the solute equation
      INTEGER CIN,IBC,MRNO,NX,NY,NZ,NXYZ
      INTEGER C10,C11,C12,C20,C21,C22
      INTEGER C30,C31,C32,C40,C41,C42
      INTEGER C50,C51,C52,C60,C61,C62
      INTEGER C70,C71,C72,C80,C81,C82
      INTEGER C90,C91,C92
      INTEGER CELLNO
      DIMENSION C(*),DC(*),
     X     TSXY(*),TSXZ(*),TSYX(*),TSYZ(*),
     X     TSZX(*),TSZY(*),
     X     RS(*),
     X     RHS(0:*),CIN(6,*),IBC(*),MRNO(*),
     X     LOCHFB(NX,NY,NZ,2)
C.....Function for cell number
      CELLNO(I,J,K)=(K-1)*NXY+(J-1)*NX+I
C.....Function for updated concentration
      CNP(MM)=C(MM)+DC(MM)
C.....Function for cross derivative dispersive flux term
      CRDF1(XTC,X1P,X2P,X1,X2)=XTC*(X1P+X2P-X1-X2)
C...
      DO 340 M=1,NXYZ
         MA=MRNO(M)
C.....Decode M into I,J,K
         CALL MTOIJK(M,I,J,K,NX,NY)
         MIMJK=CIN(3,M)
         IF(MIMJK.GT.0) THEN
            MIMJPK=CELLNO(I-1,J+1,K)
            MIMJMK=CELLNO(I-1,J-1,K)
            MIMJKP=CELLNO(I-1,J,K+1)
            MIMJKM=CELLNO(I-1,J,K-1)
         ENDIF
         MIPJK=CIN(4,M)
         IF(MIPJK.GT.0) THEN
            MIPJPK=CELLNO(I+1,J+1,K)
            MIPJMK=CELLNO(I+1,J-1,K)
            MIPJKP=CELLNO(I+1,J,K+1)
            MIPJKM=CELLNO(I+1,J,K-1)
         ENDIF
         MIJMK=CIN(2,M)
         MIJPK=CIN(5,M)
         MIJKM=CIN(1,M)
         IF(MIJKM.GT.0) THEN
            MIJMKM=CELLNO(I,J-1,K-1)
            MIJPKM=CELLNO(I,J+1,K-1)
         ENDIF
         MIJKP=CIN(6,M)
         IF(MIJKP.GT.0) THEN
            MIJMKP=CELLNO(I,J-1,K+1)
            MIJPKP=CELLNO(I,J+1,K+1)
         ENDIF
C.....Zero coefficients are used to suppress equation terms that are
C.....     not present due to geometry of boundaries and/or equations
C.....     that are not being solved
C
C.....Calculate explicit cross-derivative dispersive flux terms
         UCROSC=0.
cgzh  create local cell scheme for C gradient calc's
cgzh  this will enable cells across HFB's to be excluded
cgzh for current layer, relative to C2 which is at I,J,K:
c
c    C10  C11  C12
c    C20  C2   C22
c    C30  C31  C32
c
cgzh for layer above (k-1)
c
c    C40  C41  C42
c    C50  C51  C52
c    C60  C61  C62
c
cgzh for layer below (k+1)
c
c    C70  C71  C72
c    C80  C81  C82
c    C90  C91  C92
c
c
C.....X-direction
         FTXYDP=0.
         FTXYDM=0.
         IF(MIJMK.GT.0.AND.MIJPK.GT.0) THEN
cgzh BEGIN for xy, cell m (i,j,k)
             IF(MIPJK.GT.0) THEN
                C11=MIJMK
                C12=MIPJMK
                          C31=MIJPK
                  C32=MIPJPK
                  MULT=1.0
                IF(LOCHFB(I,J-1,K,2).EQ.1.OR.
     X            LOCHFB(I+1,J-1,K,2).EQ.1) THEN
                      C11=CELLNO(I,J,K)
                      C12=MIPJK
                      MULT=2.0
                  END IF
                IF(LOCHFB(I,J,K,2).EQ.1.OR.
     X            LOCHFB(I+1,J,K,2).EQ.1) THEN
                      C31=CELLNO(I,J,K)
                      C32=MIPJK
                      MULT=2.0
                  END IF
                      FTXYDP=CRDF1((TSXY(M)*MULT),CNP(C32),
     X            CNP(C31),CNP(C12),CNP(C11))
             END IF
c            IF(MIPJK.GT.0) FTXYDP=CRDF1(TSXY(M),CNP(MIPJPK),CNP(MIJPK),
c     X           CNP(MIPJMK),CNP(MIJMK))
cgzh END for xy, cell m (i,j,k)
cgzh BEGIN for xy, cell m-1 (i-1,j,k)
             IF(MIMJK.GT.0) THEN
                          C10=MIMJMK
                          C11=MIJMK
                          C30=MIMJPK
                          C31=MIJPK
                          MULT=1.0
                IF(LOCHFB(I-1,J-1,K,2).EQ.1.OR.
     X            LOCHFB(I,J-1,K,2).EQ.1) THEN
                      C10=MIMJK
                      C11=CELLNO(I,J,K)
                      MULT=2.0
                  END IF
                IF(LOCHFB(I-1,J,K,2).EQ.1.OR.
     X            LOCHFB(I,J,K,2).EQ.1) THEN
                      C30=MIMJK
                      C31=CELLNO(I,J,K)
                      MULT=2.0
                  END IF
                      FTXYDM=CRDF1((TSXY(M-1)*MULT),CNP(C31),
     X              CNP(C30),CNP(C11),CNP(C10))
               END IF
c            IF(MIMJK.GT.0) FTXYDM=CRDF1(TSXY(M-1),CNP(MIJPK),
c     X              CNP(MIMJPK),CNP(MIJMK),CNP(MIMJMK))
cgzh END for xy, cell m-1 (i-1,j,k)
         ENDIF
         FTXZDP=0.
         FTXZDM=0.
cgzh skip these, gradient in layer dir
         IF(MIJKM.GT.0.AND.MIJKP.GT.0) THEN
            IF(MIPJK.GT.0) FTXZDP=CRDF1(TSXZ(M),CNP(MIPJKP),CNP(MIJKP),
     X           CNP(MIPJKM),CNP(MIJKM))
            IF(MIMJK.GT.0) FTXZDM=CRDF1(TSXZ(M-1),CNP(MIJKP),
     X                CNP(MIMJKP),CNP(MIJKM),CNP(MIMJKM))
         ENDIF
C.....Y-direction
         FTYXDP=0.
         FTYXDM=0.
         IF(MIMJK.GT.0.AND.MIPJK.GT.0) THEN
cgzh BEGIN for yx, cell m (i,j,k)
            IF(MIJPK.GT.0) THEN
                          C20=MIMJK
                          C30=MIMJPK
                          C22=MIPJK
                          C32=MIPJPK
                          MULT=1.0
                IF(LOCHFB(I-1,J,K,1).EQ.1.OR.
     X            LOCHFB(I-1,J+1,K,1).EQ.1) THEN
                      C20=CELLNO(I,J,K)
                      C30=MIJPK
                      MULT=2.0
                  END IF
                IF(LOCHFB(I,J,K,1).EQ.1.OR.
     X            LOCHFB(I,J+1,K,1).EQ.1) THEN
                      C22=CELLNO(I,J,K)
                      C32=MIJPK
                      MULT=2.0
                  END IF
                      FTYXDP=CRDF1((TSYX(M)*MULT),CNP(C32),CNP(C22),
     X           CNP(C30),CNP(C20))
              END IF
c                    FTYXDP=CRDF1(TSYX(M),CNP(MIPJPK),CNP(MIPJK),
c     X           CNP(MIMJPK),CNP(MIMJK))
cgzh END for yx, cell m (i,j,k)
cgzh BEGIN for yx, cell m-1 (i,j-1,k)
            IF(MIJMK.GT.0) THEN
                          C10=MIMJMK
                          C20=MIMJK
                          C12=MIPJMK
                          C22=MIPJK
                          MULT=1.0
                IF(LOCHFB(I-1,J-1,K,1).EQ.1.OR.
     X            LOCHFB(I-1,J,K,1).EQ.1) THEN
                      C10=MIJMK
                      C20=CELLNO(I,J,K)
                      MULT=2.0
                  END IF
                IF(LOCHFB(I,J-1,K,1).EQ.1.OR.
     X            LOCHFB(I,J,K,1).EQ.1) THEN
                      C12=MIJMK
                      C22=CELLNO(I,J,K)
                      MULT=2.0
                  END IF
                      FTYXDM=CRDF1((TSYX(MIJMK)*MULT),CNP(C22),
     X                CNP(C12),CNP(C20),CNP(C10))
              END IF
c                    FTYXDM=CRDF1(TSYX(MIJMK),CNP(MIPJK),
c     X                CNP(MIPJMK),CNP(MIMJK),CNP(MIMJMK))
cgzh END for yx, cell m-1 (i,j-1,k)
         ENDIF
         FTYZDP=0.
         FTYZDM=0.
cgzh skip these, gradient in layer dir
         IF(MIJKM.GT.0.AND.MIJKP.GT.0) THEN
            IF(MIJPK.GT.0) FTYZDP=CRDF1(TSYZ(M),CNP(MIJPKP),CNP(MIJKP),
     X           CNP(MIJPKM),CNP(MIJKM))
            IF(MIJMK.GT.0) FTYZDM=CRDF1(TSYZ(MIJMK),CNP(MIJKP),
     X                CNP(MIJMKP),CNP(MIJKM),CNP(MIJMKM))
         ENDIF
C.....Z-direction
         FTZXDP=0.
         FTZXDM=0.
         IF(MIMJK.GT.0.AND.MIPJK.GT.0) THEN
cgzh BEGIN for zx, cell m (i,j,k)
            IF(MIJKP.GT.0) THEN
                          C82=MIPJKP
                          C22=MIPJK
                          C80=MIMJKP
                          C20=MIMJK
                          MULT=1.0
                IF(LOCHFB(I-1,J,K,1).EQ.1.OR.
     X            LOCHFB(I-1,J,K+1,1).EQ.1) THEN
                      C20=CELLNO(I,J,K)
                      C80=MIJKP
                      MULT=2.0
                  END IF
                IF(LOCHFB(I,J,K,1).EQ.1.OR.
     X            LOCHFB(I,J,K+1,1).EQ.1) THEN
                      C22=CELLNO(I,J,K)
                      C82=MIJKP
                      MULT=2.0
                  END IF
                      FTYXDP=CRDF1((TSZX(M)*MULT),CNP(C82),CNP(C22),
     X           CNP(C80),CNP(C20))
              END IF
cgzh            IF(MIJKP.GT.0) FTZXDP=CRDF1(TSZX(M),CNP(MIPJKP),CNP(MIPJK),
cgzh     X           CNP(MIMJKP),CNP(MIMJK))
cgzh END for zx, cell m (i,j,k)
cgzh BEGIN for zx, cell m-1 (i,j,k-1)
            IF(MIJKM.GT.0) THEN
                          C22=MIPJK
                          C52=MIPJKM
                          C50=MIMJKM
                          C20=MIMJK
                          MULT=1.0
                IF(LOCHFB(I-1,J,K,1).EQ.1.OR.
     X            LOCHFB(I-1,J,K-1,1).EQ.1) THEN
                      C20=CELLNO(I,J,K)
                      C50=MIJKM
                      MULT=2.0
                  END IF
                IF(LOCHFB(I,J,K,1).EQ.1.OR.
     X            LOCHFB(I,J,K-1,1).EQ.1) THEN
                      C22=CELLNO(I,J,K)
                      C52=MIJKM
                      MULT=2.0
                  END IF
                      FTYXDP=CRDF1((TSZX(M)*MULT),CNP(C22),CNP(C52),
     X           CNP(C50),CNP(C20))
              END IF
cgzh            IF(MIJKM.GT.0) FTZXDM=CRDF1(TSZX(MIJKM),CNP(MIPJK),
cgzh     X             CNP(MIPJKM),CNP(MIMJK),CNP(MIMJKM))
cgzh END for zx, cell m-1 (i,j,k)
         ENDIF
         FTZYDP=0.
         FTZYDM=0.
         IF(MIJMK.GT.0.AND.MIJPK.GT.0) THEN
cgzh BEGIN for zy, cell m (i,j,k)
            IF(MIJKP.GT.0) THEN
                          C91=MIJPKP
                          C31=MIJPK
                          C71=MIJMKP
                          C11=MIJMK
                          MULT=1.0
                IF(LOCHFB(I-1,J,K,2).EQ.1.OR.
     X            LOCHFB(I-1,J,K+1,2).EQ.1) THEN
                      C11=CELLNO(I,J,K)
                      C71=MIJKP
                      MULT=2.0
                  END IF
                IF(LOCHFB(I,J,K,2).EQ.1.OR.
     X            LOCHFB(I,J,K+1,2).EQ.1) THEN
                      C31=CELLNO(I,J,K)
                      C91=MIJKP
                      MULT=2.0
                  END IF
                      FTYXDP=CRDF1((TSZY(M)*MULT),CNP(C91),CNP(C31),
     X           CNP(C71),CNP(C11))
              END IF
cgzh old code
cgzh            IF(MIJKP.GT.0) FTZYDP=CRDF1(TSZY(M),CNP(MIJPKP),CNP(MIJPK),
cgzh     X           CNP(MIJMKP),CNP(MIJMK))
cgzh END for zy, cell m (i,j,k)
cgzh BEGIN for zy, cell m-1 (i,j,k-1)
            IF(MIJKM.GT.0) THEN
                          C31=MIJPK
                          C61=MIJPKM
                          C11=MIJMK
                          C41=MIJMKM
                          MULT=1.0
                IF(LOCHFB(I-1,J,K,2).EQ.1.OR.
     X            LOCHFB(I-1,J,K-1,2).EQ.1) THEN
                      C11=CELLNO(I,J,K)
                      C41=MIJKM
                      MULT=2.0
                  END IF
                IF(LOCHFB(I,J,K,2).EQ.1.OR.
     X            LOCHFB(I,J,K-1,2).EQ.1) THEN
                      C31=CELLNO(I,J,K)
                      C61=MIJKM
                      MULT=2.0
                  END IF
                      FTYXDP=CRDF1((TSZY(M)*MULT),CNP(C31),CNP(C61),
     X           CNP(C11),CNP(C41))
              END IF
cgzh            IF(MIJKM.GT.0) FTZYDM=CRDF1(TSZY(MIJKM),CNP(MIJPK),
cgzh     X           CNP(MIJPKM),CNP(MIJMK),CNP(MIJMKM))
cgzh END for zy, cell m-1 (i,j,k)
         ENDIF
         UCROSC=FTXYDP+FTXZDP+FTYXDP+FTYZDP+FTZXDP+
     X        FTZYDP-FTXYDM-FTXZDM-FTYXDM-FTYZDM-FTZXDM-FTZYDM
C.....Right-hand-side
         RHS(MA)=RS(M)+UCROSC
  340 CONTINUE
      RETURN
      END
C
      SUBROUTINE RHSN(C,TSX,TSY,TSZ,RS,
     X     NX,NY,NZ,NXY,NXYZ)
C.....Calculates right hand side terms at time level n,
      INTEGER NX,NY,NZ,NXYZ
      DIMENSION C(NXYZ),TSX(NXYZ),TSY(NXYZ),TSZ(NXYZ),RS(NXYZ)
      INTEGER CELLNO
C...
C.....Cell number function
      CELLNO(I,J,K)=(K-1)*NXY+(J-1)*NX+I
C...
C.....Calculate right hand side dispersive flux terms
C.....      (not cross-dispersive flux terms)
C.....Inactive cells are excluded by zero flow rate and transmissivity
      DO 252 K=1,NZ
         DO 251 J=1,NY
            DO 250 I=1,NX
               M=CELLNO(I,J,K)
               IF(I.LT.NX) THEN
C.....X-direction
                  RS(M+1)=RS(M+1)-TSX(M)*(C(M+1)-C(M))
                  RS(M)=RS(M)+TSX(M)*(C(M+1)-C(M))
               ENDIF
               IF(J.LT.NY) THEN
C.....Y-direction
                  MIJPK=CELLNO(I,J+1,K)
                  RS(MIJPK)=RS(MIJPK)-TSY(M)*(C(MIJPK)-C(M))
                  RS(M)=RS(M)+TSY(M)*(C(MIJPK)-C(M))
               ENDIF
               IF(K.LT.NZ) THEN
C.....Z-direction
                  MIJKP=CELLNO(I,J,K+1)
                  RS(MIJKP)=RS(MIJKP)-TSZ(M)*(C(MIJKP)-C(M))
                  RS(M)=RS(M)+TSZ(M)*(C(MIJKP)-C(M))
               ENDIF
  250       CONTINUE
  251    CONTINUE
  252 CONTINUE
      RETURN
      END
C
      SUBROUTINE ASEMBL(
     X     TSX,TSY,TSZ,
     X     VA,VAD,RHS,CIN,IBOUND,MRNO,FDTMTH,
     X     NX,NY,NZ,NXY,NXYZ,NRN,
     X     NCOL,NROW,NLAY)
C.....Assembles the matrix coefficients and right hand side vector
C.....     for the solute equation
      INTEGER CIN,MRNO,NX,NY,NZ,NXYZ
      INTEGER CELLNO
      DIMENSION 
     X     TSX(NXYZ),TSY(NXYZ),TSZ(NXYZ),
     X     VA(6,*),
     X     VAD(NXYZ),RHS(0:NXYZ),CIN(6,*),MRNO(*)
      DIMENSION IBOUND(NCOL,NROW,NLAY)
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
      PARAMETER(ICXM=3,ICXP=4,ICYM=2,ICYP=5,ICZM=1,ICZP=6)
C...
C.....Function for cell number
      CELLNO(I,J,K)=(K-1)*NXY+(J-1)*NX+I
C...
C.....Compute and assemble coefficients in difference equations
C.....     cell-by-cell
      DO 340 M=1,NXYZ
         MA=MRNO(M)
C.....Asemble VA for red nodes only and VAD and RHS for all nodes
         IF(MA.LE.NRN) THEN
         DO 10 IC=1,6
            VA(IC,MA)=0.
   10    CONTINUE
         ENDIF
C.....Decode M into I,J,K
         CALL MTOIJK(M,I,J,K,NX,NY)
C.....Solve trivial equation for excluded cells, iterative solver
         II=I+ISCOL1-1
         JJ=J+ISROW1-1
         KK=K+ISLAY1-1
         IF(IBOUND(II,JJ,KK).EQ.0) THEN
            VAD(MA)=1.
            RHS(MA)=0.
            GO TO 340
         ENDIF
C.....Conductances treated explicitly
         TSXM=0.
         MIMJK=CIN(3,M)
         IF(MIMJK.GT.0) THEN
            TSXM=TSX(MIMJK)
         ENDIF
         TSXP=0.
         MIPJK=CIN(4,M)
         IF(MIPJK.GT.0) THEN
            TSXP=TSX(M)
         ENDIF
         TSYM=0.
         MIJMK=CIN(2,M)
         IF(MIJMK.GT.0) TSYM=TSY(MIJMK)
         TSYP=0.
         MIJPK=CIN(5,M)
         IF(MIJPK.GT.0) TSYP=TSY(M)
         TSZM=0.
         MIJKM=CIN(1,M)
         IF(MIJKM.GT.0) THEN
            TSZM=TSZ(MIJKM)
         ENDIF
         TSZP=0.
         MIJKP=CIN(6,M)
         IF(MIJKP.GT.0) THEN
            TSZP=TSZ(M)
         ENDIF
C.....Zero coefficients are used to suppress equation terms that are
C.....     not present due to geometry of boundaries and/or equations
C.....     that are not being solved
         VAD(MA)=1.
C.....Install conductance terms for red nodes only
         IF(MA.LE.NRN) THEN
C.....X-direction
         VA(ICXM,MA)=-FDTMTH*TSXM
         VA(ICXP,MA)=-FDTMTH*TSXP
C.....Y-direction
         VA(ICYM,MA)=-FDTMTH*TSYM
         VA(ICYP,MA)=-FDTMTH*TSYP
C.....Z-direction
         VA(ICZM,MA)=-FDTMTH*TSZM
         VA(ICZP,MA)=-FDTMTH*TSZP
         ENDIF
C.....Diagonal term
         VAD(MA)=VAD(MA)+FDTMTH*(TSXM+TSXP+TSYM+TSYP+TSZM+TSZP)
  340 CONTINUE
      RETURN
      END
C
C     ****************************************************************
C
      SUBROUTINE LOADT(
     *     IBOUND,NCOL,NROW,NLAY,
     *     DISPCC,DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,
     *     DISPLL,DISPLC,DISPLR,
     *     NSCOL,NSROW,NSLAY,
     X     THCK,POR,RF,TIMV)
C.....Loads the conductance factors into one-dimensional arrays from
C.....     the 3-dimensional arrays
C.....     in MOC3D with extra factors
      DIMENSION
     *  IBOUND(NCOL,NROW,NLAY),
     *  THCK(NSCOL,NSROW,NSLAY),
     *  POR(NSCOL,NSROW,NSLAY),RF(NSCOL,NSROW,NSLAY)
      DIMENSION
     *  DISPCC(NSCOL,NSROW,NSLAY),DISPCR(NSCOL,NSROW,NSLAY),
     *  DISPCL(NSCOL,NSROW,NSLAY),DISPRR(NSCOL,NSROW,NSLAY),
     *  DISPRC(NSCOL,NSROW,NSLAY),DISPRL(NSCOL,NSROW,NSLAY),
     *  DISPLL(NSCOL,NSROW,NSLAY),DISPLC(NSCOL,NSROW,NSLAY),
     *  DISPLR(NSCOL,NSROW,NSLAY)
C
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C...
      DO 10 IZ=1,NSLAY
         KK=IZ+ISLAY1-1
         DO 20 IY=1,NSROW
            II=IY+ISROW1-1
            DO 30 IX=1,NSCOL
               JJ=IX+ISCOL1-1
               IF(IBOUND(JJ,II,KK).NE.0) THEN
               TORF2=TIMV/(POR(IX,IY,IZ)*RF(IX,IY,IZ))
               TRFPRB=TORF2/THCK(IX,IY,IZ)
               DISPCC(IX,IY,IZ)=DISPCC(IX,IY,IZ)*TRFPRB
               DISPCR(IX,IY,IZ)=DISPCR(IX,IY,IZ)*TRFPRB
               DISPCL(IX,IY,IZ)=DISPCL(IX,IY,IZ)*TRFPRB
               DISPRR(IX,IY,IZ)=DISPRR(IX,IY,IZ)*TRFPRB
               DISPRC(IX,IY,IZ)=DISPRC(IX,IY,IZ)*TRFPRB
               DISPRL(IX,IY,IZ)=DISPRL(IX,IY,IZ)*TRFPRB
               DISPLL(IX,IY,IZ)=DISPLL(IX,IY,IZ)*TORF2
               DISPLC(IX,IY,IZ)=DISPLC(IX,IY,IZ)*TORF2
               DISPLR(IX,IY,IZ)=DISPLR(IX,IY,IZ)*TORF2
               ENDIF
   30       CONTINUE
   20    CONTINUE
   10 CONTINUE
      RETURN
      END
C
      SUBROUTINE MTOIJK(M,I,J,K,NX,NY)
C.....Returns the index (I,J,K) of the point with
C.....     natural index M.
C...
      NXY = NX*NY
      IMOD = MOD(M,NXY)
      K = (M-IMOD)/NXY + MIN(1,IMOD)
      KR = IMOD
      IF (KR .EQ. 0) KR = NXY
      IMOD = MOD(KR,NX)
      J = (KR-IMOD)/NX + MIN(1,IMOD)
      I = IMOD
      IF (I .EQ. 0) I = NX
      RETURN
      END
C
C  DSP6HFB  
C
C  DSP6HFB  MODIFY DISPERSION COEFFICIENTS (set mech disp = to 0)
C           ACCORDING TO HFB FACES
C***********************************************
C
      SUBROUTINE DSP6HFB(IBOUND,     
     *    DISPCC,DISPCR,DISPRR,DISPRC,DISPCL,DISPRL,
     *    POR,THCK,DIFFUS,DELCOL,DELROW,
     *    NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,
     *    IOUTS,HFBR,NHFB)
C
      DIMENSION IBOUND(NCOL,NROW,NLAY),
     *  DISPCC(NSCOL,NSROW,NSLAY),DISPCR(NSCOL,NSROW,NSLAY),
     *  DISPRR(NSCOL,NSROW,NSLAY),DISPRC(NSCOL,NSROW,NSLAY),
     *  DISPCL(NSCOL,NSROW,NSLAY),DISPRL(NSCOL,NSROW,NSLAY),
     *  POR(NSCOL,NSROW,NSLAY),THCK(NSCOL,NSROW,NSLAY),
     *  HFBR(5,NHFB)
      DIMENSION DELCOL(NCOL),DELROW(NROW)
C
      COMMON/HFBCOM/NBRLAY(200)
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C gzh 05/08/2000 used SHFB1N code; altered for MOC3D disp+HFB
C1------INITIALIZE ERROR FLAG TO ZERO.
      IERFLG=0
C
C2------CHECK HFB DATA ONE LAYER AT A TIME.
      II=0
      DO 100 K=1,NLAY
C
C2A-----IF ZERO BARRIER IN LAYER, THEN GO TO NEXT LAYER.
      IF (NBRLAY(K).EQ.0) GOTO 100
cgzh skip if not in subgrid
        IF(K.LT.ISLAY1.OR.K.GT.ISLAY2) GOTO 100
C
C2B-----CHECK EACH BARRIER IN LAYER K.
      DO 90 JJ=1,NBRLAY(K)
      II=II+1
C
C2C----FIND ROW AND COLUMN NUMBERS OF THE TWO CELLS ON BOTH SIDES
C2C----OF THE BARRIER
cgzh these are fixed in hfb so that i1 j1 is always topmost or leftmost
      I1=HFBR(1,II)
      J1=HFBR(2,II)
      I2=HFBR(3,II)
      J2=HFBR(4,II)
cgzh skip if either is no-flow
        IF(IBOUND(I1,J1,K).eq.0) GOTO 90
        IF(IBOUND(I2,J2,K).eq.0) GOTO 90
cgzh skip if not in subgrid
        IF(I1.LT.ISROW1.OR.I1.GT.ISROW2) GOTO 90
        IF(I2.LT.ISROW1.OR.I2.GT.ISROW2) GOTO 90
        IF(J1.LT.ISCOL1.OR.J1.GT.ISCOL2) GOTO 90
        IF(J2.LT.ISCOL1.OR.J2.GT.ISCOL2) GOTO 90
cgzh correct for subgrid, needed for lochfb array
      KS=K-ISLAY1+1
      IS=I1-ISROW1+1
      JS=J1-ISCOL1+1
C
C2D----IF I1=I2, BARRIER IS BETWEEN TWO CELLS ON THE SAME ROW.
      IF (I1.NE.I2) GOTO 10
C
C2E----IF J2-J1=1, THE TWO CELLS ARE NEXT TO ONE ANOTHER (DATA OK).
C2E----OTHERWISE, PRINT ERROR MESSAGE AND SET ERROR FLAG TO 1.
      IF ((J2-J1).NE.1) GOTO 80
C
C2BI---MODIFY DISPCC,DISPCR AND DISPCL TO ACCOUNT FOR BARRIER.
cgzh HARD-WIRED TO DIFFUSION ONLY (CROSS PRODUCT TERMS=0.0)
      CC2INV=1.0/(DELCOL(J1)*DELCOL(J1+1))
      PORB1=POR(JS,IS,KS)*THCK(JS,IS,KS)
      PORB2=POR(JS+1,IS,KS)*THCK(JS+1,IS,KS)
      HFBDFF=DIFFUS*2.D0*PORB1*PORB2/
     *       (PORB1+PORB2)*CC2INV
        DISPCC(JS,IS,KS)=HFBDFF
        DISPCR(JS,IS,KS)=0.0
        DISPCL(JS,IS,KS)=0.0
C
cgzh clean up (or get rid of?)
        write(IOUTS,*) 'CC dir: CELL, DIFF', JS,IS,KS,HFBDFF
        write(IOUTS,*) 'DISPCC(js,is,ks)', DISPCC(JS,IS,KS)
      GOTO 90
cgzh
C
C2G----IF J1=J2, BARRIER IS BETWEEN TWO CELLS ON THE SAME COLUMN.
C2G----OTHERWISE, PRINT ERROR MESSAGE AND SET ERROR FLAG TO 1.
   10 IF (J1.NE.J2) GOTO 80
C
C2H----IF I2-I1=1, THE TWO CELLS ARE NEXT TO ONE ANOTHER (DATA OK).
C2H----OTHERWISE, PRINT ERROR MESSAGE AND SET ERROR FLAG TO 1.
      IF ((I2-I1).NE.1) GOTO 80
C
C2F-----MODIFY DISPRR,DISPRC,AND DISPRL TO ACCOUNT FOR BARRIER.
cgzh HARD-WIRED TO DIFFUSION ONLY (CROSS PRODUCT TERMS=0.0)
C
      RR2INV=1.0/(DELROW(I1)*DELROW(I1+1))
      PORB1=POR(JS,IS,KS)*THCK(JS,IS,KS)
      PORB2=POR(JS,IS+1,KS)*THCK(JS,IS+1,KS)
      HFBDFF=DIFFUS*2.D0*PORB1*PORB2/
     *       (PORB1+PORB2)*RR2INV
        DISPRR(JS,IS,KS)=HFBDFF
        DISPRC(JS,IS,KS)=0.0
        DISPRL(JS,IS,KS)=0.0
cgzh clean this up
        write(IOUTS,*) 'RR dir: CELL, DIFF', JS,IS,KS,HFBDFF
        write(IOUTS,*) 'DISPRR(js,is,ks)', DISPRR(JS,IS,KS)
      GOTO 90
C
C2BJ---PRINT ERROR MESSAGE AND SET ERROR FLAG.
   80 WRITE (IOUTS,1) II
    1 FORMAT (1X,'DSP6HFB: ERROR DETECTED IN LOCATION DATA OF', 
     *  ' BARRIER NO.',I4)
      IERFLG=1
   90 CONTINUE
  100 CONTINUE
C
C3-----HALT EXECUTION IF ERRORS ARE DETECTED.
      IF (IERFLG.EQ.1) STOP
C
C4-----RETURN
      RETURN
      END
